Index: code/branches/campaignHS15/src/orxonox/controllers/ActionpointController.cc
===================================================================
--- code/branches/campaignHS15/src/orxonox/controllers/ActionpointController.cc	(revision 10881)
+++ code/branches/campaignHS15/src/orxonox/controllers/ActionpointController.cc	(revision 10882)
@@ -364,6 +364,5 @@
             (this->getProtect()->getWorldOrientation()* (targetRelativePosition)));
         this->setTargetPosition(targetAbsolutePosition);
-        this->actionCounter_ += this->actionCounter_ < 100000 ? 1 : -this->actionCounter_ ;
-        if (this->actionConter_ % 3 == 0)
+        if (this->actionCounter_ % 3 == 0)
             this->setTargetOrientation(this->getProtect()->getWorldOrientation());
     }
@@ -387,4 +386,5 @@
         }
         this->setAction(Action::NONE);
+        this->bHasTargetPosition_ = false;
     }
     void ActionpointController::moveBackToTop()
@@ -419,5 +419,6 @@
             return;
         // orxout (internal_error) << "Size of actions is " << this->parsedActionpoints_.size() << endl;
-        this->startAttackingEnemiesThatAreClose();
+        if (this->actionCounter_ % 5 == 0)
+            this->startAttackingEnemiesThatAreClose();
         //No action -> pop one from stack
         if (this->action_ == Action::NONE || this->bTakenOver_)
@@ -427,7 +428,9 @@
                 Point p = { Action::FIGHTALL, "", Vector3::ZERO, false };
                 this->parsedActionpoints_.push_back (p);
+
             }
             this->executeActionpoint();
             this->bTakenOver_ = false;
+            this->action();
         }
         //Action fightall -> fight till nobody alive
@@ -445,5 +448,10 @@
                 {
                     this->nextActionpoint();
-                    return;
+
+                    if (!(this->parsedActionpoints_.empty() && this->loopActionpoints_.empty()))
+                    {
+                        this->action();
+                    }
+                    
                 }
             }
@@ -468,5 +476,5 @@
                 {
                     this->nextActionpoint();
-                    return;
+                    this->action();
                 }
             }
@@ -488,5 +496,5 @@
                     {
                         this->nextActionpoint();
-                        return;
+                        this->action();
                     }
                 }
@@ -498,5 +506,5 @@
             {
                 this->nextActionpoint();   
-                return;
+                this->action();
             }
         }
@@ -505,6 +513,6 @@
             if (!this->getProtect())
             {
-                this->nextActionpoint(); 
-                return;
+                this->nextActionpoint();
+                this->action(); 
             }
             this->stayNearProtect();
@@ -515,5 +523,5 @@
             {
                 this->nextActionpoint();
-                return;
+                this->action();
             }
         }
@@ -525,4 +533,6 @@
             this->bShooting_ = this->canFire();                
         }
+        this->actionCounter_ += this->actionCounter_ < 100000 ? 1 : -this->actionCounter_ ;
+
     }
     void ActionpointController::takeActionpoints (std::vector<Point > vector, std::vector<Point > loop, bool b)
Index: code/branches/campaignHS15/src/orxonox/controllers/DivisionController.cc
===================================================================
--- code/branches/campaignHS15/src/orxonox/controllers/DivisionController.cc	(revision 10881)
+++ code/branches/campaignHS15/src/orxonox/controllers/DivisionController.cc	(revision 10882)
@@ -117,4 +117,8 @@
         {
             this->myFollower_ = newFollower;
+            if (this->hasWingman())
+            {
+                this->myWingman_->takeActionpoints (std::vector<Point>(), std::vector<Point>(), false);
+            }
             return true;
         }
@@ -135,6 +139,6 @@
         if (this->myFollower_)
             return true;
-        else
-            return false;
+        
+        return false;
     }
 }
Index: code/branches/campaignHS15/src/orxonox/controllers/FlyingController.cc
===================================================================
--- code/branches/campaignHS15/src/orxonox/controllers/FlyingController.cc	(revision 10881)
+++ code/branches/campaignHS15/src/orxonox/controllers/FlyingController.cc	(revision 10882)
@@ -39,5 +39,5 @@
         this->rotationProgress_ = 0;
         this->spread_ = 200;
-        this->tolerance_ = 80;
+        this->tolerance_ = 60;
         RegisterObject( FlyingController );
     }