Index: /code/branches/hoverHS15/data/levels/Hover.oxw
===================================================================
--- /code/branches/hoverHS15/data/levels/Hover.oxw	(revision 10894)
+++ /code/branches/hoverHS15/data/levels/Hover.oxw	(revision 10895)
@@ -15,4 +15,5 @@
   include("templates/spaceshipPirate.oxt")
   include("templates/spaceshipHover.oxt")
+  include("overlays/HoverHUD.oxo")
 ?>
 
Index: /code/branches/hoverHS15/data/overlays/HoverHUD.oxo
===================================================================
--- /code/branches/hoverHS15/data/overlays/HoverHUD.oxo	(revision 10895)
+++ /code/branches/hoverHS15/data/overlays/HoverHUD.oxo	(revision 10895)
@@ -0,0 +1,45 @@
+<Template name="HoverHUD">
+  <OverlayGroup name="HoverHUD" scale = "1, 1">
+  </OverlayGroup>
+</Template>
+
+
+<Template name="spaceshiphoverhud">
+  <OverlayGroup name = "spaceshiphoverhud" scale = "1, 1">
+    <TimeHUD
+     name       = "Timer"
+     position  = "0.95, 0.02"
+     pickpoint = "0.0, 0.0"
+     font      = "ShareTechMono"
+     textsize  = 0.05
+     colour    = "1.0, 1.0, 1.0, 1.0"
+     align     = "right"
+    />
+
+    <FlagHUD
+     position  = "0.05, 0.02"
+     size      = "0.18, 0.05"
+    />
+
+    <HUDHealthBar
+     name              = "HealthBar1"
+     background        = "Orxonox/HealthBarBackground"
+     size              = "0.35, 0.0875"
+     position          = "0.0 , 0.97"
+     pickpoint         = "0, 1"
+     bartexture        = "healthbar_bar.png"
+     textfont          = "VeraMono"
+     textusebarcolour  = true
+     textsize          = 0.039
+     textoffset        = "0.315, 0.05"
+     textpickpoint     = "0, 0"
+     textalign         = "right"
+     correctaspect     = false
+     textcorrectaspect = false
+    >
+      <BarColour position = 0.0 colour = "0.7,0.2,0.2" />
+      <BarColour position = 0.5 colour = "0.7,0.7,0.2" />
+      <BarColour position = 1.0 colour = "0.2,0.7,0.2" />
+    </HUDHealthBar>
+ </OverlayGroup>
+</Template>
Index: /code/branches/hoverHS15/src/modules/hover/CMakeLists.txt
===================================================================
--- /code/branches/hoverHS15/src/modules/hover/CMakeLists.txt	(revision 10894)
+++ /code/branches/hoverHS15/src/modules/hover/CMakeLists.txt	(revision 10895)
@@ -4,4 +4,6 @@
 HoverWall.cc
 HoverOrigin.cc
+TimeHUD.cc
+FlagHUD.cc
 HoverFlag.cc
 )
Index: /code/branches/hoverHS15/src/modules/hover/FlagHUD.cc
===================================================================
--- /code/branches/hoverHS15/src/modules/hover/FlagHUD.cc	(revision 10895)
+++ /code/branches/hoverHS15/src/modules/hover/FlagHUD.cc	(revision 10895)
@@ -0,0 +1,94 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Cyrill Burgener
+ *
+ */
+
+#include "FlagHUD.h"
+
+#include <OgreOverlayManager.h>
+#include <OgreMaterialManager.h>
+#include <OgrePanelOverlayElement.h>
+
+#include "core/CoreIncludes.h"
+#include "core/XMLPort.h"
+
+namespace orxonox
+{
+    RegisterClass(FlagHUD);
+
+    FlagHUD::FlagHUD(Context* context) : OrxonoxOverlay(context)
+    {
+        RegisterObject(FlagHUD);
+
+        this->panel_ = static_cast<Ogre::PanelOverlayElement*>(Ogre::OverlayManager::getSingleton()
+            .createOverlayElement("Panel", "FlagHUD_Panel_" + getUniqueNumberString()));
+        this->panel_->setMaterialName("Hover/Flag");
+        this->overlay_->add2D(this->panel_);
+
+        this->flagCount_ = 5;
+        setFlagCount(5);
+    }
+
+    void FlagHUD::setFlagCount(int flagCount) {
+        this->panel_->setDimensions(
+            this->panel_->_getRelativeWidth() / ((float) flagCount_) * ((float) flagCount),
+            this->panel_->_getRelativeHeight()
+            );
+        this->panel_->setTiling(flagCount, 1.0f);
+
+        this->flagCount_ = flagCount;
+    }
+
+    /*void FlagHUD::tick(float dt)
+    {
+        SUPER(FlagHUD, tick, dt);
+
+        if (this->hoverGame)
+        {
+            setFlagCount(2);
+        }
+    }*/
+
+    void FlagHUD::changedOwner()
+    {
+        SUPER(FlagHUD, changedOwner);
+
+        if (this->getOwner() && this->getOwner()->getGametype())
+        {
+            this->hoverGame = orxonox_cast<Hover*>(this->getOwner()->getGametype());
+        }
+        else
+        {
+            this->hoverGame = 0;
+        }
+    }
+
+    FlagHUD::~FlagHUD()
+    {
+        if (this->isInitialized())
+        {
+            Ogre::OverlayManager::getSingleton().destroyOverlayElement(this->panel_);
+        }
+    }
+}
Index: /code/branches/hoverHS15/src/modules/hover/FlagHUD.h
===================================================================
--- /code/branches/hoverHS15/src/modules/hover/FlagHUD.h	(revision 10895)
+++ /code/branches/hoverHS15/src/modules/hover/FlagHUD.h	(revision 10895)
@@ -0,0 +1,58 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Cyrill Burgener
+ *
+ */
+
+#ifndef _FlagHUD_H__
+#define _FlagHUD_H__
+
+#include "overlays/OverlaysPrereqs.h"
+
+#include "util/Math.h"
+#include "util/OgreForwardRefs.h"
+#include "core/BaseObject.h"
+#include "overlays/OrxonoxOverlay.h"
+#include "Hover.h"
+
+namespace orxonox
+{
+    class _OverlaysExport FlagHUD : public OrxonoxOverlay //, public Tickable
+    {
+    public:
+        FlagHUD(Context* context);
+        virtual ~FlagHUD();
+
+    	//virtual void tick(float dt);
+        virtual void changedOwner();
+
+        virtual void setFlagCount(int flagCount);
+
+
+    private:
+        Hover* hoverGame;
+        Ogre::PanelOverlayElement* panel_;
+        int flagCount_;
+    };
+}
+#endif /* _FlagHUD_H__ */
Index: /code/branches/hoverHS15/src/modules/hover/Hover.cc
===================================================================
--- /code/branches/hoverHS15/src/modules/hover/Hover.cc	(revision 10894)
+++ /code/branches/hoverHS15/src/modules/hover/Hover.cc	(revision 10895)
@@ -102,5 +102,5 @@
         
         RegisterObject(Hover);
-        //this->setHUDTemplate("HoverHUD");
+        this->setHUDTemplate("HoverHUD");
     }
 
Index: /code/branches/hoverHS15/src/modules/hover/TimeHUD.cc
===================================================================
--- /code/branches/hoverHS15/src/modules/hover/TimeHUD.cc	(revision 10895)
+++ /code/branches/hoverHS15/src/modules/hover/TimeHUD.cc	(revision 10895)
@@ -0,0 +1,114 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Cyrill Burgener
+ *
+ */
+
+#include "TimeHUD.h"
+
+#include "core/CoreIncludes.h"
+#include "core/XMLPort.h"
+#include "util/Convert.h"
+#include "Hover.h"
+
+namespace orxonox
+{
+    RegisterClass(TimeHUD);
+
+    TimeHUD::TimeHUD(Context* context) : OverlayText(context)
+    {
+        RegisterObject(TimeHUD);
+
+        this->_time = 0.0f;
+        this->_running = false;
+        this->hoverGame = 0;
+    }
+
+    void TimeHUD::XMLPort(Element& xmlelement, XMLPort::Mode mode)
+    {
+        SUPER(TimeHUD, XMLPort, xmlelement, mode);
+    }
+
+    inline std::string getTimeString(float time) {
+        std::ostringstream ss;
+
+        int h = ((int) (time * 100.0f)) % 100;
+        int s = ((int) time) % 60;
+        int m = (int) (time / 60.0f);
+
+        ss << m << ":";
+
+        if(s < 10) {
+            ss << 0;
+        }
+        ss << s << ":";
+
+        if(h < 10) {
+            ss << 0;
+        }
+        ss << h << "s";
+        return ss.str();
+    }
+
+    void TimeHUD::tick(float dt)
+    {
+        SUPER(TimeHUD, tick, dt);
+
+        if(this->_running) {
+            this->_time += dt;
+        }
+        if (this->hoverGame)
+        {
+            this->setCaption(getTimeString(this->_time));
+        }
+        
+    }
+
+    void TimeHUD::changedOwner()
+    {
+        SUPER(TimeHUD, changedOwner);
+
+        if (this->getOwner() && this->getOwner()->getGametype())
+        {
+            this->hoverGame = orxonox_cast<Hover*>(this->getOwner()->getGametype());
+        }
+        else
+        {
+            this->hoverGame = 0;
+        }
+    }
+
+    void TimeHUD::setRunning(bool running) 
+    {
+        this->_running = running;
+    }
+
+    bool TimeHUD::isRunning() {
+        return this->_running;
+    }
+
+    void TimeHUD::reset()
+    {
+        this->_time = 0;
+    }
+}
Index: /code/branches/hoverHS15/src/modules/hover/TimeHUD.h
===================================================================
--- /code/branches/hoverHS15/src/modules/hover/TimeHUD.h	(revision 10895)
+++ /code/branches/hoverHS15/src/modules/hover/TimeHUD.h	(revision 10895)
@@ -0,0 +1,56 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Cyrill Burgener
+ *
+ */
+
+#ifndef _TimeHUD_H__
+#define _TimeHUD_H__
+
+#include "hover/HoverPrereqs.h"
+
+#include "tools/interfaces/Tickable.h"
+#include "overlays/OverlayText.h"
+
+namespace orxonox
+{
+    class _HoverExport TimeHUD : public OverlayText, public Tickable
+    {
+        public:
+            TimeHUD(Context* context);
+
+            virtual void tick(float dt);
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+            virtual void changedOwner();
+
+            virtual void setRunning(bool running);
+            virtual bool isRunning();
+            virtual void reset();
+
+        private:
+            Hover* hoverGame;
+            float _time;
+            bool _running;
+    };
+}
+#endif /* _TimeHUD_H__ */