Index: code/branches/hoverHS15/data/overlays/HoverHUD.oxo
===================================================================
--- code/branches/hoverHS15/data/overlays/HoverHUD.oxo	(revision 10898)
+++ code/branches/hoverHS15/data/overlays/HoverHUD.oxo	(revision 10900)
@@ -8,5 +8,5 @@
   <OverlayGroup name = "spaceshiphoverhud" scale = "1, 1">
     <TimeHUD
-     name       = "Timer"
+     name       = "TimerHUD"
      position  = "0.95, 0.02"
      pickpoint = "0.0, 0.0"
@@ -18,4 +18,5 @@
 
     <FlagHUD
+     name      = "FlagHUD"
      position  = "0.05, 0.02"
      size      = "0.18, 0.05"
Index: code/branches/hoverHS15/src/modules/hover/FlagHUD.cc
===================================================================
--- code/branches/hoverHS15/src/modules/hover/FlagHUD.cc	(revision 10898)
+++ code/branches/hoverHS15/src/modules/hover/FlagHUD.cc	(revision 10900)
@@ -52,4 +52,8 @@
 
     void FlagHUD::setFlagCount(int flagCount) {
+        if(flagCount == 0){
+            this->panel_->hide();
+            return;
+        }
         this->panel_->setDimensions(
             this->panel_->_getRelativeWidth() / ((float) flagCount_) * ((float) flagCount),
@@ -61,13 +65,11 @@
     }
 
-    /*void FlagHUD::tick(float dt)
+    void FlagHUD::tick(float dt)
     {
         SUPER(FlagHUD, tick, dt);
 
-        if (this->hoverGame)
-        {
-            setFlagCount(2);
-        }
-    }*/
+            setFlagCount(this->hoverGame->getFlags());
+        
+    }
 
     void FlagHUD::changedOwner()
Index: code/branches/hoverHS15/src/modules/hover/FlagHUD.h
===================================================================
--- code/branches/hoverHS15/src/modules/hover/FlagHUD.h	(revision 10898)
+++ code/branches/hoverHS15/src/modules/hover/FlagHUD.h	(revision 10900)
@@ -38,5 +38,5 @@
 namespace orxonox
 {
-    class _OverlaysExport FlagHUD : public OrxonoxOverlay //, public Tickable
+    class _OverlaysExport FlagHUD : public OrxonoxOverlay , public Tickable
     {
     public:
@@ -44,5 +44,5 @@
         virtual ~FlagHUD();
 
-    	//virtual void tick(float dt);
+    	virtual void tick(float dt);
         virtual void changedOwner();
 
Index: code/branches/hoverHS15/src/modules/hover/Hover.cc
===================================================================
--- code/branches/hoverHS15/src/modules/hover/Hover.cc	(revision 10898)
+++ code/branches/hoverHS15/src/modules/hover/Hover.cc	(revision 10900)
@@ -116,4 +116,5 @@
         if(firstTick)
         {
+
             std::fill( g_Maze, g_Maze + NumCells * NumCells, 0 );
             g_PtX=0;
@@ -143,4 +144,6 @@
             for ( int i = 0; i < 5; i++ )
                 flagVector.push_back(new HoverFlag(origin_->getContext(), rand()%10, rand()%10));
+
+            Flags_ = flagVector.size();
             
             //new HoverFlag(origin_->getContext()); //Rechts in Y Richtung
@@ -154,10 +157,16 @@
             }
         }
-
-
-
-    }
-
-    
+        Flags_ = flagVector.size();
+
+
+
+    }
+
+     int Hover::getFlags()
+    {
+
+        // Call start for the parent class.
+        return Flags_;
+    }   
 
     void Hover::start()
Index: code/branches/hoverHS15/src/modules/hover/Hover.h
===================================================================
--- code/branches/hoverHS15/src/modules/hover/Hover.h	(revision 10898)
+++ code/branches/hoverHS15/src/modules/hover/Hover.h	(revision 10900)
@@ -88,5 +88,5 @@
                        { this->origin_ = origin; }
 
-
+            int getFlags();
             WeakPtr<HoverOrigin> origin_;
 
@@ -95,5 +95,5 @@
             int RandomInt();
             int RandomInt4();
-
+            int Flags_;
 
             bool IsDirValid( eDirection Dir );
Index: code/branches/hoverHS15/src/modules/hover/TimeHUD.cc
===================================================================
--- code/branches/hoverHS15/src/modules/hover/TimeHUD.cc	(revision 10898)
+++ code/branches/hoverHS15/src/modules/hover/TimeHUD.cc	(revision 10900)
@@ -43,4 +43,5 @@
         this->_running = false;
         this->hoverGame = 0;
+        setRunning(true);
     }
 
@@ -82,4 +83,6 @@
             this->setCaption(getTimeString(this->_time));
         }
+        if(this->hoverGame->getFlags() == 0)
+            setRunning(false);
         
     }