Index: code/branches/campaignHS15/data/levels/shuttleRetaliation.oxw
===================================================================
--- code/branches/campaignHS15/data/levels/shuttleRetaliation.oxw	(revision 10903)
+++ code/branches/campaignHS15/data/levels/shuttleRetaliation.oxw	(revision 10904)
@@ -237,4 +237,12 @@
     </EventMultiTrigger>
 
+    <EventMultiTrigger name="spawned" stayactive=true activations=1>
+        <events>
+            <trigger>
+                <EventListener event="spawntrigger" />
+            </trigger>
+        </events>
+    </EventMultiTrigger>
+
     <DistanceTrigger name="reachedSector" position="<?lua printC(cSector) ?>" distance="<?lua print(radSector) ?>" target="SpaceShip" beaconMode="identify" targetname="Commander" stayactive=true />
 
@@ -263,36 +271,36 @@
       <events>
           <activity>
-              <Trigger mode=or>
-                  <EventTrigger invert=true>
-                      <events>
-                          <trigger>
-                              <EventListener event="alliesReachedWait" />
-                          </trigger>
-                      </events>
-                  </EventTrigger>
-                  <EventTrigger>
-                      <events>
-                          <trigger>
-                              <EventListener event="noMercy" />
-                          </trigger>
-                      </events>
-                  </EventTrigger>
-                  <Trigger mode=and>
-                      <EventTrigger>
-                          <events>
-                              <trigger>
-                                  <EventListener event="fightBegun" />
-                              </trigger>
-                          </events>
-                      </EventTrigger>
-                      <EventTrigger invert=true>
-                          <events>
-                              <trigger>
-                                  <EventListener event="oneUnitLeft" />
-                              </trigger>
-                          </events>
-                      </EventTrigger>
-                  </Trigger>
-              </Trigger>
+                <Trigger mode=or>
+                    <EventTrigger invert=true>
+                        <events>
+                            <trigger>
+                                <EventListener event="alliesReachedWait" />
+                            </trigger>
+                        </events>
+                    </EventTrigger>
+                    <EventTrigger>
+                        <events>
+                            <trigger>
+                                <EventListener event="noMercy" />
+                            </trigger>
+                        </events>
+                    </EventTrigger>
+                    <Trigger mode=and>
+                        <EventTrigger>
+                            <events>
+                                <trigger>
+                                    <EventListener event="fightBegun" />
+                                </trigger>
+                            </events>
+                        </EventTrigger>
+                        <EventTrigger invert=true>
+                            <events>
+                                <trigger>
+                                    <EventListener event="oneUnitLeft" />
+                                </trigger>
+                            </events>
+                        </EventTrigger>
+                    </Trigger>
+                </Trigger>  
           </activity>
       </events>
@@ -454,5 +462,5 @@
     </EventMultiTrigger>
 
-    <EventMultiTrigger name="AllUnitsDown" stayactive=true>
+    <EventMultiTrigger name="allUnitsDown" stayactive=true>
         <events>
             <trigger>
@@ -799,5 +807,5 @@
      <events>
          <trigger>
-             <EventListener event="AllUnitsDown" />
+             <EventListener event="allUnitsDown" />
          </trigger>
      </events>
@@ -961,28 +969,50 @@
         <events>
             <activity>
-                <EventListener event="cloakBeacon" />
+              <EventListener event="enemyPlanetVisible" />
             </activity>
             <visibility>
-                <EventListener event="cloakBeacon" />
+              <EventListener event="enemyPlanetVisible" />
             </visibility>
         </events>
+    </Planet>
+
+    <EventMultiTrigger name="enemyPlanetMulti">
+     <events>
+         <trigger>
+             <EventListener event="enemyPlanet" />
+         </trigger>
+     </events>
+    </EventMultiTrigger>
+
+    <EventMultiTrigger name="enemyPlanetVisible">
+     <events>
+         <trigger>
+             <Trigger mode=and>
+                <EventTrigger>
+                      <events>
+                          <trigger>
+                              <EventListener event="cloakBeacon" />
+                          </trigger>
+                      </events>
+                  </EventTrigger>
+                  <EventTrigger invert=true>
+                      <events>
+                          <trigger>
+                              <EventListener event="enemyPlanetMulti" />
+                          </trigger>
+                      </events>
+                  </EventTrigger>
+              </Trigger>
+         </trigger>
+     </events>
+    </EventMultiTrigger>
+
+    <!-- Pawn that represents the planet during destruction -->
+
+    <Pawn team=1 health=300 name="enemyPlanet" position="<?lua printC(cEnemyBasePlanet) ?>" collisionType=dynamic mass=5000000 radarname="Enemy home planet">
         <collisionShapes>
-            <SphereCollisionShape radius="5000" position="0,0,0" />
-        </collisionShapes>
-    </Planet>
-
-    <!-- Pawn that represents the planet during destruction -->
-
-    <Pawn active=false team=1 initialhealth=500 health=500 maxhealth=500 position="<?lua printC(cEnemyBasePlanet) ?>" radarname="Enemy Home Planet" name="enemyPlanet">
-        <events>
-            <activity>
-                <EventListener event="oneUnitLeft" />
-            </activity>
-        </events>
-        <collisionShapes>
-            <SphereCollisionShape radius="6000" position="0,0,0" />
+          <SphereCollisionShape position="0,0,0" radius=5500/>
         </collisionShapes>
     </Pawn>
-
     <!--SHIPS -->
 
@@ -1007,5 +1037,5 @@
               do
               ?>
-              <Actionpoint position="<?lua printC(addC(cPathToEntry[i], rUnit)) ?>" action="fly" />
+              <Actionpoint position="<?lua printC(addC(cPathToEntry[i], rUnit)) ?>" action="fly"/>
               <?lua end ?>
            </actionpoints>
@@ -1068,5 +1098,5 @@
       </events>
       <controller>
-        <DivisionController name="enemyControll" active=false team=1 formationMode="diamond" spread=100>
+        <DivisionController name="enemyController" active=false team=1 formationMode="diamond" spread=100>
           <actionpoints>
               <Actionpoint position="<?lua printC(cEnemyNow) ?>" action="fightall" />
@@ -1089,5 +1119,5 @@
       </events>
       <controller>
-        <SectionController name="enemyControll" active=false team=1>
+        <SectionController name="enemyController" active=false team=1>
         </SectionController>
       </controller>
@@ -1107,5 +1137,5 @@
       </events>
       <controller>
-        <WingmanController name="enemyControll" active=false team=1>
+        <WingmanController name="enemyController" active=false team=1>
         </WingmanController>
       </controller>
@@ -1125,5 +1155,5 @@
       </events>
       <controller>
-        <WingmanController name="enemyControll" active=false team=1>
+        <WingmanController name="enemyController" active=false team=1>
         </WingmanController>
       </controller>