Index: code/branches/planetLevelHS15/data/levels/luaTest.oxw
===================================================================
--- code/branches/planetLevelHS15/data/levels/luaTest.oxw	(revision 10904)
+++ code/branches/planetLevelHS15/data/levels/luaTest.oxw	(revision 10905)
@@ -23,13 +23,16 @@
 <?lua
 function randomHouses(x,y,cellSize)
-    returnString = ""
+    returnString = "<SpawnPoint team=0 position=\"" .. x*cellSize/2 .. "," .. y*cellSize/2 .. ",500\" lookat=\"0,0,0\" spawnclass=SpaceShip pawndesign=spaceshipescort direction=\"0,1,0\" />"
     for currentX = 1, x, 1 do
       for currentY = 1, y, 1 do
-        houseNr = math.floor(math.random()*4 + 1)
-        orientation = math.floor(math.random()*4)
-        houses = {"Glasstower1","ETH","Hausc1","PrimeTower"}
-        scales = {100,100,100,7}
-        collisionShapes = {"","","<BoxCollisionShape position=\"0,0,+50\" halfExtents=\"100, 100, 50\" /><BoxCollisionShape position=\"-50,50,200\" halfExtents=\"50, 50, 100\" scale=\"1.4286\"/><BoxCollisionShape      position=\"50,0,300\" halfExtents=\"50, 100, 200\" scale=\"1.4286\"/><BoxCollisionShape      position=\"50,50,600\" halfExtents=\"50, 50, 100\" scale=\"1.4286\"/><BoxCollisionShape      position=\"-25,-25,150\" halfExtents=\"25, 25, 50\" scale=\"1.4286\"/><BoxCollisionShape      position=\"-25,+75,350\" halfExtents=\"25, 25, 50\" scale=\"1.4286\"/><BoxCollisionShape      position=\"75,-25,550\" halfExtents=\"25, 25, 50\" scale=\"1.4286\"/>","",""}
-        returnString = returnString .. "<StaticEntity collisionType=\"static\" position=\"" .. (currentX*cellSize - (cellSize/2)) .. "," .. (currentY*cellSize - (cellSize/2)) .. ",0\" direction=\"0,1,0\" pitch=\"0\" roll=\"0\" yaw=\"" .. (orientation*90) .. "\">  <attached> <Model position=\"0,0,0\" mesh=\"" .. houses[houseNr] .. ".mesh\" scale=\"" .. scales[houseNr] .. "\"/></attached><collisionShapes>" .. collisionShapes[houseNr] .. "</collisionShapes></StaticEntity>\n\n"
+        houseNr = math.floor(math.random()*6 + 1)
+        orientation = math.floor(math.random()*4)*90
+        houses = {"Glasstower1","ETH","Hausc1","PrimeTower","Hausc2","101"}
+        scales = {100,80,100,100,100,100}
+        collisionShapes = {--[[Glasstower1]]"<BoxCollisionShape position=\"0,405,0\" halfExtents=\"90,405,90\" /><BoxCollisionShape  position=\"0,855,0\" halfExtents=\"110, 45, 110\" /><BoxCollisionShape      position=\"0,957,0\" halfExtents=\"5, 70, 5\" />  ",--[[ETH]]"<BoxCollisionShape      position=\"-83.496,22.423,3.439\" halfExtents=\"89.5,30.4,151.5\" /><BoxCollisionShape      position=\"105.607996,22.905,-137.980005\" halfExtents=\"31.40,23.55,39.25\" /><BoxCollisionShape      position=\"105.607996,22.905,137.078003\" halfExtents=\"31.40,23.55,39.25\" /><BoxCollisionShape      position=\"65.356,22.905,118.208997\" halfExtents=\"31.40,23.55,20.40\" /><BoxCollisionShape      position=\"65.356,22.905,-121.712\" halfExtents=\"31.40,23.55,20.40\" /><SphereCollisionShape  position=\"44.985001,60.196997,0.352 \" radius=\"31.65\" />",--[[Hausc1]]"<BoxCollisionShape position=\"0,71.43,0\" halfExtents=\"142.86, 71.43, 142.86\" /><BoxCollisionShape position=\"-71.43,285.72,-71.43\" halfExtents=\"71.43, 142.86, 71.43\" /><BoxCollisionShape position=\"71.43,428.58,0\" halfExtents=\"71.43, 285.72, 142.86\" /><BoxCollisionShape position=\"71.43,857.16,-71.43\" halfExtents=\"71.43, 142.86, 71.43\" /><BoxCollisionShape position=\"-35.715,214.29,35.715\" halfExtents=\"35.715, 71.43, 35.715\" /><BoxCollisionShape position=\"-35.715,500.01,-107.145\" halfExtents=\"35.715, 71.43, 35.715\" /><BoxCollisionShape position=\"107.145,785.73,35.715\" halfExtents=\"35.715, 71.43, 35.715\" />",--[[PrimeTower]]"<BoxCollisionShape      position=\"-16.1,278.6,-053.\" halfExtents=\"063,296,063\" yaw=\"-16.5\" /> <BoxCollisionShape      position=\"007.1,278.6,027.3\" halfExtents=\"065,296,065\" yaw=\"-28\" /><BoxCollisionShape      position=\"012.8,278.6,-633\" halfExtents=\"076,296,076\" yaw=\"4\" /> <BoxCollisionShape      position=\"0.2318,278.6,-135.4\" halfExtents=\"067.7,296,067.7\" yaw=\"-28\" />",--[[Hausc2]]"<BoxCollisionShape      position=\"0,349.999,-166.667\" halfExtents=\"83.333, 349.999, 83.333\" /><BoxCollisionShape      position=\"0,349.999,166.667\" halfExtents=\"83.333, 349.999, 83.333\" /><BoxCollisionShape      position=\"41.666,291.666,0\" halfExtents=\"41.666, 58.333, 83.333\" /><BoxCollisionShape      position=\"-41.666,524.999,0\" halfExtents=\"41.666, 58.333, 83.333\" /> ",--[[101]]"<BoxCollisionShape    position=\"0,565.7,0\" halfExtents=\"76,565.7,76\" /><BoxCollisionShape position=\"-2.8,1210,1\" halfExtents=\"39,82,39\" />"}
+        if (currentX > 0 and currentX < x and currentY > 1 --[[and currentY ~= y]]) then
+        returnString = returnString .. "<StaticEntity collisionType=\"static\" position=\"" .. (currentX*cellSize) .. "," .. (currentY*cellSize - (cellSize/2)) .. ",0\" direction=\"0,1,0\" pitch=\"0\" roll=\"0\" yaw=\"" .. orientation .. "\">  <attached> <Model position=\"0,0,0\" mesh=\"" .. houses[houseNr] .. ".mesh\" scale=\"" .. scales[houseNr] .. "\"/></attached><collisionShapes>" .. collisionShapes[houseNr] .. "</collisionShapes></StaticEntity>\n\n"
+        end
+        returnString = returnString .. "<StaticEntity collisionType=\"static\" position=\"" .. (currentX*cellSize - cellSize/2) .. "," .. (currentY*cellSize) .. ",0\" direction=\"0,1,0\" pitch=\"0\" roll=\"0\" yaw=\"0\">  <attached> <Model position=\"0,0,0\" mesh=\"CityGround.mesh\" scale=\"" .. cellSize .. "\"/></attached><collisionShapes><BoxCollisionShape position=\"0,0,0\" halfExtents=\"500,0,500\"/></collisionShapes></StaticEntity>\n\n"
       end
     end
@@ -51,7 +54,7 @@
 
    
-    <SpawnPoint team=0 position="-200,0,0" lookat="0,0,0" spawnclass=SpaceShip pawndesign=spaceshipescort direction="0,1,0" />
 
-    <?lua print(randomHouses(2,2,1000)) ?>
+
+    <?lua print(randomHouses(5,5,600)) ?>
   <StaticEntity position="0,0,0" direction="0,0,0" collisionType=static mass=0 friction=0.01 yaw=90 roll=90 >
     <attached> 